﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	//import flash.display.DisplayObject;
	import flash.media.Microphone;
	import flash.media.SoundTransform;
	import flash.display.*;
	import flash.geom.*;
	import fl.motion.Color;

	public class Boussoler extends Sprite
	{
		private var col:uint = 10;
		private var line:uint = 10;
		private var clip:Sprite;
		private var clipBack:Sprite;
		private var angle:Number;
		private var fillType:String = GradientType.LINEAR;
		private var spreadMethod:String =SpreadMethod.PAD;
		var mic=Microphone.getMicrophone();
		private var colors:Array=[0xccccc,0xff9933, 0xff4488]
		private var alphas:Array =[ 1,1,1];
		private var ratios:Array =[ 0,100,255];
		private var matr:Matrix = new Matrix();
		
		public function Boussoler()
		
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		
		}
		
		
		private function fullhandler(e:FullScreenEvent):void
		{
			/*while(numChildren>0){
				var c:DisplayObject = getChildAt(0);
				removeChildAt(0);
				c = null;
			}*/
			init();
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			init();
			if (mic!=null) {
				mic.setLoopBack(true);
				mic.setUseEchoSuppression(true);

				var transform:SoundTransform=mic.soundTransform;
				transform.volume=0;
				mic.soundTransform=transform;
				
			} else {
			}
		}
		
		public function get activityLevel():Number{
			return mic.activityLevel;
			trace(mic.activityLevel);
		}
		
		private function init():void
		{
			var nbrl:Number = stage.stageWidth/col;
			var nbrh:Number = stage.stageHeight/line;
			clipBack= new Sprite();
			matr.createGradientBox(250,750,200,0,0);
			clipBack.graphics.beginGradientFill(fillType,colors,alphas,ratios,matr,spreadMethod);
			clipBack.graphics.drawRect(0,0,800,600);
			addChildAt(clipBack,0);
			
			for(var i:uint=1;i<line;i++){
			
				for(var j:uint=1;j<col;j++){
//					
					trace(colors[i]);
					clip = new Sprite();
					//var color:int =0xffffff;
					//matr.createGradientBox(25,50,0,0,0);
					//clip.graphics.beginGradientFill(fillType,colors,alphas,ratios,matr,spreadMethod);
					//clip.graphics.lineStyle(0.3,mic.activityLevel*2,0xffffff);
					/*clip.graphics.moveTo(0,-mic.activityLevel);
					clip.graphics.lineTo(0,mic.activityLevel);*/
					
					
					clip.graphics.beginFill(1,0xffffff);
					clip.graphics.lineStyle(1,mic.activityLevel*2,0xffffff);
					clip.graphics.drawCircle(0,0,mic.activityLevel/8);
					clip.graphics.endFill();
					
					clip.x = j*nbrl;
					clip.y = i*nbrh;
					addChild(clip);
					clip.addEventListener(Event.ENTER_FRAME,enterHandler);
					
				}
			}
		}
		
		private function enterHandler(e:Event):void
		{	//angle = Math.atan((e.currentTarget.y-mic.activityLevel)/(mic.activityLevel/10));
			angle =mic.activityLevel*8;
			e.currentTarget.rotation = angle*180/Math.PI+Math.sin(angle)*500;
			e.currentTarget.scaleY = angle;
			//angle = Math.atan((e.currentTarget.y-mouseX)/(e.currentTarget.x-mouseX));
			/*e.currentTarget.rotation = angle*180/Math.PI+Math.sin(angle)*500;
			e.currentTarget.scaleY = angle;*/
			trace(mic.activityLevel);
		}
	}
}